/*#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,fma,tune=native")
*/
#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define double long double
#define F first
#define S second
using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (min(a.F, a.S) != min(b.F, b.S)) {
        return min(a.F, a.S) < min(b.F, b.S);
    }
    return max(a.F, a.S) < max(b.F, b.S);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    std::sort(a.begin(), a.end(), cmp);
    for (int i = 0; i < n; ++i) {
        if (a[i].first > a[i].second) {
            swap(a[i].first, a[i].second);
        }
    }
    bool e = true;
    for (int i = 1; i < n; ++i) {
        if (a[i].first < a[i - 1].first || a[i].second < a[i - 1].second) {
            e = false;
        }
    }
    if (e) {
        for (int i = 0; i < n; ++i) {
            cout << a[i].first << " ";
        }
        cout << "\n";
        for (int i = 0; i < n; ++i) {
            cout << a[i].second << " ";
        }
    } else {
        cout << -1;
    }
    return 0;
}
