/*#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,fma,tune=native")
*/
#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define double long double
#define F first
#define S second
using namespace std;

struct Vector {
    int x, y;

    void in() {
        ll x1, y1;
        cin >> x1 >> y1;
        x = x1, y = y1;
    }

    Vector operator-(Vector a) {
        return {x - a.x, y - a.y};
    }

    Vector operator+(Vector a) {
        return {x + a.x, y + a.y};
    }

    int operator%(Vector a) {
        return x * a.y - y * a.x;
    }

    int operator*(Vector a) {
        return x * a.x + y * a.y;
    }

    int len2() {
        return x * x + y * y;
    }
};

pair<int, int> getdist(Vector a, Vector b, Vector p) {
    b = b - a;
    p = p - a;
    return {abs(b % p) * abs(b % p), b.len2()};
}

bool less1(pair<int, int> a, pair<int, int> b) {
    if (b.F == -1) {
        return 1;
    }
    return a.F * b.S < a.S * b.F;
}

bool peron(Vector a, Vector b, Vector p) {
    a = b - a;
    p = p - a;
    a = a - a;
    return b * p >= 0 && (a - b) * (p - b) >= 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    vector<Vector> a(3);
    for (int i = 0; i < 3; ++i) {
        a[i].in();
    }
    pair<Vector, Vector> ans;
    pair<int, int> now = {-1, -1};
    for (int i = 0; i < 3; ++i) {
        for (int j = i + 1; j < 3; ++j) {
            int oth = 3 - i - j;
            pair<int, int> h = getdist(a[i], a[j], a[oth]);
            if (less1(h, now)) {
                now = h;
                ans = {a[i], a[j]};
            }
        }
    }
    cout << (ll) ans.F.x << " " << (ll) ans.F.y << " " << (ll) ans.S.x << " " << (ll) ans.S.y;
    return 0;
}
