/*#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,fma,tune=native")
*/
#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define double long double
#define F first
#define S second
using namespace std;

struct Vector {
    int x, y;

    void in() {
        ll x1, y1;
        cin >> x1 >> y1;
        x = x1, y = y1;
    }

    Vector operator-(Vector a) {
        return {x - a.x, y - a.y};
    }

    Vector operator+(Vector a) {
        return {x + a.x, y + a.y};
    }

    int operator%(Vector a) {
        return x * a.y - y * a.x;
    }

    int operator*(Vector a) {
        return x * a.x + y * a.y;
    }

    int len2() {
        return x * x + y * y;
    }
};

double getdist(Vector a, Vector b, Vector p) {
    b = b - a;
    p = p - a;
    return abs(b % p) / sqrtl(b.len2());
}

bool peron(Vector a, Vector b, Vector p) {
    a = b - a;
    p = p - a;
    a = a - a;
    return b * p >= 0 && (a - b) * (p - b) >= 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    vector<Vector> a(3);
    for (int i = 0; i < 3; ++i) {
        a[i].in();
    }
    pair<Vector, Vector> ans;
    double now = -1;
    bool e = 0;
    for (int i = 0; i < 2; ++i) {
        for (int j = i + 1; j < 3; ++j) {
            int oth = 3 - i - j;
            double h = getdist(a[i], a[j], a[oth]);
            if (!e || h < now) {
                e = 1;
                now = h;
                ans = {a[i], a[j]};
            }
        }
    }
    cout << (ll) ans.F.x << " " << (ll) ans.F.y << " " << (ll) ans.S.x << " " << (ll) ans.S.y;
    return 0;
}
