#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC target("arch=sandybridge")

#define int long long
#define all(x) x.begin(),x.end()

void solve();

void solve1();

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
using multiordered_set = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

struct line {
    ld k = 0, b = INF;
    ld get(ll x) {
        return k * x + b;
    }
};

struct st {
    line lx;
    ll l = -1, r = -1;
};

struct li_chao {
    vector<st> tree = {{0, INF}};
    ll build() {
        tree.emplace_back();
        return (int)tree.size() - 1;
    }
    void change(ll v, ll l, ll r, line ln) {
        if (l > r) {
            return;
        }
        ll m = (l + r) / 2;
        bool t1 = tree[v].lx.get(m) > ln.get(m);
        bool t2 = tree[v].lx.get(l) > ln.get(l);
        if (t1) {
            swap(tree[v].lx, ln);
        }
        if (tree[v].l == -1) {
            tree[v].l = build();
        }
        if(tree[v].r == -1) {
            tree[v].r = build();
        }
        if (t1 != t2) {
            change(tree[v].l, l, m - 1, ln);
        } else {
            change(tree[v].r, m + 1, r, ln);
        }
    }
    ld get(ll v, ll l, ll r, ll x) {
        if (l > r) {
            return INF;
        }
        ld tc = tree[v].lx.get(x);
        ll m = (l + r) / 2;
        if (tree[v].l == -1) {
            tree[v].l = build();
        }
        if(tree[v].r == -1) {
            tree[v].r = build();
        }
        if (x < m) {
            return min(tc, get(tree[v].l, l, m - 1, x));
        } else {
            return min(tc, get(tree[v].r, m + 1, r, x));
        }
    }
};

void solve() {
    ll n, m;
    ld c;
    cin >> n >> m >> c;
    vector<pair<ld, ld>> a;
    a.emplace_back(0, 0);
    for (int i = 0; i < n; i++) {
        ll x, t;
        cin >> x >> t;
        a.emplace_back(x, t);
    }
    a.emplace_back(m, 0);
    vector<ld> dp(n + 2, INF);
    li_chao t;
    dp[0] = 0;
    t.change(0, 0, 1e9, {-2 * a[0].first / c, a[0].first * a[0].first / c + dp[0] + a[0].second});
    for (int i = 1; i < n + 2; i++) {
        dp[i] = t.get(0, 0, 1e9, a[i].first) + a[i].first * a[i].first / c;
        t.change(0, 0, 1e9, {-2 * a[i].first / c, a[i].first * a[i].first / c + dp[i] + a[i].second});
    }
    cout << fixed << setprecision(20);
    cout << dp[n + 1];
}
