#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC target("arch=sandybridge")

#define int long long
#define all(x) x.begin(),x.end()

void solve();

void solve1();

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
using multiordered_set = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    //cin >> q;
    while (q--) {
        solve1();
    }
}

void solve() {
    ld c, h;
    cin >> c >> h;
    if (c * c - 4 * h * h < 0) {
        cout << -1;
        return;
    }
    cout << c * h / 2;
}

struct line {
    ld a, b, c;
};

struct point {
    ld x, y;
};

line get(point p1, point p2) {
    ld a = p1.y - p2.y;
    ld b = p2.x - p1.x;
    ld c = p1.x * p2.y - p2.x * p1.y;
    return {a, b, c};
}

ld dist(line l, point p) {
    return abs((l.a * p.x + l.b * p.y + l.c) / hypotl(l.a, l.b));
}

void solve1() {
    point a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    line aa = get(b, c);
    line bb = get(a, c);
    line cc = get(a, b);
    ld fir = dist(aa, a);
    ld sec = dist(bb, b);
    ld thr = dist(cc, c);
    if (fir <= sec && fir <= thr) {
        cout << b.x << ' ' << b.y << ' ' << c.x << ' ' << c.y;
        return;
    }
    if (sec <= fir && sec <= thr) {
        cout << a.x << ' ' << a.y << ' ' << c.x << ' ' << c.y;
        return;
    }
    if (thr <= sec && thr <= fir) {
        cout << b.x << ' ' << b.y << ' ' << a.x << ' ' << a.y;
        return;
    }
}