#include <bits/stdc++.h>

using namespace std;
using ll = long long;

map<pair<int, int>, char> ans;

char ask(int x, int y) {
    if (ans.find({x, y}) != ans.end()) return ans[{x, y}];
    cout << "? " << x << " " << y << endl;
    cout.flush();
    char type;
    cin >> type;
    ans[{x, y}] = type;
    return type;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m, s;
    cin >> n >> m >> s;

    if (n * m == s) {
        cout << "0\n";
        return 0;
    }
    if (s % n == 0 && s / n <= m || s % m == 0 && s / m <= n) {
        cout << "1\n";
        return 0;
    }
    for (int x = 1; x <= n; ++x) {
        if (s % x == 0 && s / x <= m) {
            cout << "2\n";
            return 0;
        }
        if ((n * m - s) % x == 0 && (n * m - s) / x <= m) {
            cout << "2\n";
            return 0;
        }
        if (2 * x != n) {
            ll t = (s - m * x) / (n - 2 * x);
            if (t >= 1 && t <= m && t * (n - 2 * x) == (s - m * x)) {
                cout << "2\n";
                return 0;
            }
        }
    }
    cout << "3\n";

    return 0;
}
