#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using db = long double;

constexpr ll infLL = 3e18;

struct line {
    long long a, b, c;

    line(long long _a, long long _b, long long _c) : a(_a), b(_b), c(_c) {};
};

struct point {
    long long x, y;

    void scan() {
        cin >> x >> y;
    }

    void print() {
        cout << x << " " << y << " ";
    }

    long long get(line l) {
        return l.a * x + l.b * y + l.c;
    }
};

line create(point a, point b) {
    return {b.y - a.y, a.x - b.x, b.x * a.y - b.y * a.x};
}

long double dist(line a, point b) {
    return fabs((long double) (a.a * b.x + a.b * b.y + a.c)) / sqrt((long double) (a.a * a.a + a.b * a.b));
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    point a, b, c;
    a.scan(), b.scan(), c.scan();
    line ab = create(a, b), ac = create(a, c), bc = create(b, c);
    if (dist(bc, a) <= dist(ac, b) && dist(bc, a) <= dist(ab, c))
        b.print(), c.print();
    else if (dist(ac, b) <= dist(bc, a) && dist(ac, b) <= dist(ab, c))
        a.print(), c.print();
    else
        a.print(), b.print();
    return 0;
}
