#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using db = long double;
#define int long long
struct pt{
    ll x, y;
};
struct line{
    ll A, B, C;
    line(pt a, pt b){
        A = b.y - a.y;
        B = a.x - b.x;
        C = -A*a.x - B*a.y;
    }
};
db dist(pt a, line ln){
    return abs((db)ln.A*a.x + ln.B*a.y + ln.C)/1.0/sqrtl((db)ln.A*ln.A + ln.B*ln.B);
}
void solve() {
    pt a, b, c;
    cin >> a.x >> a.y;
    cin >> b.x >> b.y;
    cin >> c.x >> c.y;
    pair<pt, pt> ansp;
    db ansv = 1e12;
    line ln1(a, b), ln2(b, c), ln3(a, c);
    if(dist(c, ln1) < ansv){
        ansv = dist(c, ln1);
        ansp = {a, b};
    }

    if(dist(a, ln2) < ansv){
        ansv = dist(a, ln2);
        ansp = {b, c};
    }

    if(dist(b, ln3) < ansv){
        ansv = dist(b, ln3);
        ansp = {a, c};
    }
    cout << ansp.first.x << ' ' << ansp.first.y << ' ';
    cout << ansp.second.x << ' ' << ansp.second.y;
}

int32_t main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
