#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int N = 1e5 + 5;

map<int, int> cnt[N];
map<int, int> op[N];
map<int, set<int>> mp[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    int ans = 0;

    while (q--) {
        char s;
        cin >> s;

        int v, u, c;
        cin >> v >> u >> c;

        if (s == '+') {
            if (op[v][c] > 0) {
                op[op[v][c]][c] = 0;
                op[v][c] = 0;
                ans--;
            }

            if (op[u][c] > 0) {
                op[op[u][c]][c] = 0;
                op[u][c] = 0;
                ans--;
            }

            if (cnt[u][c] == 0 && cnt[v][c] == 0) {
                ans++;
                op[u][c] = v;
                op[v][c] = u;
            }

        } else {
            if (cnt[u][c] == 1 && cnt[v][c] == 1) {
                ans--;
                op[v][c]--;
                op[u][c]--;
            }

            if (cnt[u][c] == 2) {
                bool flag = true;
                for (auto i : mp[u][c]) {
                    if (i == v) continue;

                    if (cnt[i][c] > 1) {
                        flag = false;
                    }
                }

                if (flag) {
                    ans++;
                }
            }

            if (cnt[v][c] == 2) {
                bool flag = true;
                for (auto i : mp[v][c]) {
                    if (i == u) continue;

                    if (cnt[i][c] > 1) {
                        flag = false;
                    }
                }

                if (flag) {
                    ans++;
                }
            }
        }

        if (s == '+') {
            cnt[u][c]++;
            cnt[v][c]++;

            mp[v][c].insert(u);
            mp[u][c].insert(v);
        } else {
            cnt[v][c]--;
            cnt[u][c]--;

            mp[v][c].erase(u);
            mp[u][c].erase(v);
        }

        cout << ans << '\n';
    }
}