#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int N = 1e5 + 5;

map<int, int> cnt[N];
map<int, int> op[N];
map<int, set<int>> mp[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    vector<map<ll, set<ll>>> vec(n + 1);
    int ans = 0;

    while (q--) {
        char s;
        cin >> s;

        int v, u, c;
        cin >> v >> u >> c;

        if (s == '+') {
            vec[v][c].insert(u);
            vec[u][c].insert(v);
            if (vec[v][c].size() == 1 && vec[u][c].size() == 1) {
                ans++;
            }
            if (vec[v][c].size() == 2 || vec[u][c].size() == 2) {
                ans--;
            }
        } else {
            vec[v][c].erase(u);
            vec[u][c].erase(v);
            if (vec[v][c].size() == 0) {
                ans--;
            }
            if (vec[v][c].size() == 1) {
                ll k = *vec[v][c].begin();
                if (vec[k][c].size() == 1) {
                    ans++;
                }
            } else if (vec[u][c].size() == 1){
                ll k = *vec[u][c].begin();
                if (vec[k][c].size() == 1) {
                    ans++;
                }
            }
        }
        cout << ans << '\n';
    }
}