#include <bits/stdc++.h>
using namespace std;
#define int long long
long double dist(long double x1, long double y1, long double x2, long double y2) {
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}
long double f(long double x1,long double y1, long double x2, long double y2, long double x0, long double y0) {
    if (x1 > x2) {
        swap(x1, x2);
        swap(y1, y2);
    }
    if (x2 - x1 == 0) {
        return abs(x0 - x1);
    }
    if (y2 - y1 == 0) {
        return abs(y0 - y1);
    }
    long double k, b;
    k = (y2 - y1) / (x2 - x1);
    b = y1 - k * x1;
    long double Ax = x0, Ay = y0;
    long double Bx = (Ay - b) / k, By = Ay;
    long double Cx = Ax, Cy = k * Ax + b;
    if (dist(Bx, By, Cx, Cy) == 0) return 0;
    return abs(dist(Ax, Ay, Bx, By) * dist(Ax, Ay, Cx, Cy) / dist(Bx, By, Cx, Cy));

}
void solve() {
    int x1, x2, x3, y1, y2, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    long double ans = f(x1, y1, x2, y2, x3, y3);
    int res = 1;
    if (f(x1,y1,x3,y3,x2,y2) < ans) {
        ans = f(x1,y1,x3, y3, x2, y2);
        res = 2;
    }
    if (f(x2, y2, x3, y3, x1, y1) < ans) {
        ans = f(x2, y2, x3, y3, x1, y1);
        res = 3;
    }
    if (res == 1) cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2;
    else if (res == 2) cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3;
    else cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3;
}
signed main() {
    int t = 1;

//    cin >> t;

    while (t--) {
        solve();
    }
}