#include <bits/stdc++.h>

using namespace std;

#define ui unsigned int
#define ull unsigned long long
#define ll long long
#define ld long double
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define int long long

struct line{
    ld k, b;

    line() {}

    line(ld k1, ld b1) : k(k1), b(b1) {}

    ld find_y(ld x) {
        return k * x + b;
    }
};

ld per(line l1, line l2) {
    return (ld) (l2.b - l1.b) / (l1.k - l2.k);
}

vector<line> lines;
vector<ld> dots;

void add(line f) {
    while (!lines.empty() && lines.back().find_y(dots.back()) >= f.find_y(dots.back())) {
        lines.pop_back();
        dots.pop_back();
    }
    if (lines.empty()) {
        lines.pb(f);
        dots.pb(-100);
    } else {
        dots.pb(per(lines.back(), f));
        lines.pb(f);
    }
}

ld find_ans(ld x) {
    auto it = lower_bound(all(dots), x) - dots.begin() - 1;
    return lines[it].find_y(x);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m;
    ld c;
    cin >> n >> m >> c;
    vector<ld> x(n + 2), t(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> x[i] >> t[i];
    }
    x[n + 1] = m;
    vector<ld> dp(n + 2);
    add(line(0, 0));
    for (int i = 1; i <= n + 1; ++i) {
        dp[i] = t[i] + x[i] * x[i] / c + find_ans(x[i]);
        add(line(-(x[i] / c) * 2.0, dp[i] + x[i] * x[i] / c));
    }
    cout.precision(20);
    cout << dp[n + 1];
    return 0;
}
