#include <bits/stdc++.h>
using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    map<int, map<int, int>> m; // таблица всех вершин
    map<int, int> r; // кол-во ребер цвета c
    map<int, int> ipf; // таблица неидеальных вершин цвета c

    char act;
    int v, u, c, temp;

    for (int i = 0; i < q; i++) {
        cin >> act >> v >> u >> c;

        if (act == '+') {
            m[v][c]++;
            m[u][c]++;
            r[c]++;
            
            if (m[v][c] == 1 && m[u][c] == 1) { // новое идеальное ребро
            } else { // новое неидеальное ребро (соединено с вершинами, одна из которых уже соединена с ребром этого же цвета)
                if (m[v][c] > 1) ipf[c]++;
                if (m[u][c] > 1) ipf[c]++;
            }
        } else {
            m[v][c]--;
            m[u][c]--;
            r[c]--;

            if (m[v][c] == 0 && m[u][c] == 0) { // убраное ребро было идеальным
            } else {
                if (m[v][c] > 0) ipf[c]--;
                if (m[u][c] > 0) ipf[c]--;
            }
        }

        int len = 0;
        for (auto &[col, num] : r) {
            if (ipf[col] == 0) len += num;
        }
        cout << len << "\n";
    }

    return 0;
}