#include <bits/stdc++.h>

using namespace std;

#define int long long

int one = 1;

int _gcd(int a, int b){
    if(a < b){
        swap(a, b);
    }
    if(b == 0){
        return max(one, a);
    }else{
        return _gcd(b, a % b);
    }
}

long long Resh(int x1, int y1, int x2, int y2, int x3, int y3) {
    int x = (-y1 + (y2 - y1)/(x2 - x1) + (x3*x1 - x3*x2 - y3*y2 + y3*y1)/(y1 - y2)) / ((y2 - y1) / (x2 - x1) + (x1 - x2) / (y1 - y2));
    int y = (x2 - x1) / (y2 - y1) * x + y1 - (x2 - x1) / (y2 - y1);
    int L1 = sqrt(x*x + y*y);
    return L1;
}
void solveM() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    int L1 = Resh(x1, y1, x2, y2, x3, y3);
    //cout << L1 << endl;
    int L2 = Resh(x1, y1, x3, y3, x2, y2);
    //cout << L2 << endl;
    int L3 = Resh(x2, y2, x3, y3, x1, y1);
    //cout << L3 << endl;
    if (min(L1, min(L2, L3)) == L1) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2;
    }
    else if (min(L1, min(L2, L3)) == L2) {
        cout << x1 << " " << y1 << " " << x3 << " " << y3;
    }
    else if (min(L1, min(L2, L3)) == L3) {
        cout << x2 << " " << y2 << " " << x3 << " " << y3;
    }
}
void solveB() {
    int c, h;
    cin >> c >> h;
    if(h*2 > c){
        cout << -1;
    }
    else{
        if((c * h) % 2 == 1){
            cout << (c*h)/2 << ".5";
        }
        else cout << (c*h)/2;
    }

}

bool check_prost(int x){
    for(int i = 2; i*i <= x; i++){
        if(x % i == 0){
            return false;
        }
    }
    return true;
}
vector<int> razlog(int x){
    vector<int> mult;
    for(int i = 1; i*i <=x;i++){
        if(x % i == 0){
            mult.push_back(i);
            mult.push_back(x/i);
        }
    }
    return mult;
}

void solveD(){
    int n,m,s;
    cin >> n >> m >> s;
    if(s == n * m){
        cout << 0<< endl;
        return;
    }
    if( n > s && m > s){
        cout << 2 << endl;
        return;
    }
    int cur = s;
    int res = 0;
    while(cur % n != 0 && cur % m != 0){
        cout << n << " " << m << " " << cur << endl;
        if(cur == 1){
            res++;
            break;
        }
        int x1 = cur/n;
        int x2 = cur/m;
        if(x1 * n > x2 * m){
            m-=x1;
            cur = cur - (x1 * n);
        }
        else{
            n -= x2;
            cur = cur - (x2 * m);
        }
        res++;

    }
    cout <<res+1;
}

void solveIfD(){
    int n,m,s;
    cin >> n >> m >> s;
    if(s == n * m){
        cout << 0;
        return;
    }
    if(n == 2 && m == 2 && (s==3||s==1)){
        cout << 2;
        return;
    }
    if(s % n == 0 || s % m == 0){
        cout << 1;
        return;
    }
    if(s < n || s < m){
        cout << 2;
        return;
    }
    if(check_prost(s)){
        vector<int> mult = razlog(s);
        bool f = false;
        for(int i = 1; i < mult.size(); i+=2){
            int x = mult[i-1];
            int y = mult[i];
            if(min(x,y) > min(n,m) || max(x,y) > max(n,m)) continue;
            if(min(x,y) == min(n,m) || max(x,y) == max(n,m)){
                if(min(x,y) == min(n,m) && max(x,y) == max(n,m) - 1){
                    cout << 2;
                    f = 1;
                    break;
                }
                if(max(x,y) == max(n,m) && min(x,y) == min(n,m) - 1){
                    cout << 2;
                    f = 1;
                    break;
                }
            }


        }
        if(!f) cout << 3;
        return;
    }
    else{
        cout << 2;
        return;
    }
}

void solveH(){
    int n, q;
    cin >> n >> q;
    map <int, map<int, int>> mp;
    int cnt = 0;
    while(q--){
        char x;
        int a, b, c;
        cin >> x >> a >> b >> c;
        if(x == '+'){
            mp[a][c]++;
            mp[b][c]++;
            if(mp[a][c] == 2 || mp[b][c] == 2){
                cnt--;
            }
            if(mp[a][c] == 1 && mp[b][c] == 1) {
                cnt++;
            }
        }else{
            mp[a][c]--;
            mp[b][c]--;
            if(mp[a][c] <= 1 && mp[b][c] <= 1){
                cnt++;
            }
        }
        cout  <<  max(cnt, 0ll) << endl;
    }
}
struct card{
    int x1;
    int x2;
};
bool cmp1(card x, card y){
    return x.x1 < y.x1;
}
bool cmp2(card x, card y){
    return x.x2 < y.x2;
}

void solveI(){
    int n;
    cin >> n;
    vector<card> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i].x1;
    }
    for(int i = 0; i < n; i++){
        cin >> a[i].x2;
    }
    for(int i = 0; i < n; i++){
        int maxx = max(a[i].x1, a[i].x2);
        int minn = min(a[i].x1, a[i].x2);
        a[i].x1 = minn;
        a[i].x2 = maxx;
    }
    sort(a.begin(),a.end(),cmp1);
    bool f = true;
    for(int i = 1; i < n; i++){
        if(a[i].x2 < a[i-1].x2){
            f = false;
        }
    }
    if(f){
        for(int i = 0; i < n; i++){
            cout << a[i].x1 << " ";
        }
        cout << endl;
        for(int i = 0; i < n; i++){
            cout << a[i].x2 << " ";
        }
        return;
    }
    sort(a.begin(),a.end(),cmp2);
    bool f2 = true;
    for(int i = 1; i < n; i++){
        if(a[i].x1 < a[i-1].x1){
            f2 = false;
        }
    }
    if(f2){
        for(int i = 0; i < n; i++){
            cout << a[i].x1 << " ";
        }
        cout << endl;
        for(int i = 0; i < n; i++){
            cout << a[i].x2 << " ";
        }
        return;
    }
    cout << -1;


}

signed main(){
    solveH();
}
