#include <bits/stdc++.h>
using namespace std;
#define int __int128

#define ll long long
const int INF = ((__int128)1 << 120);
struct p{
    int to = 0,c = 0;
    p () {};
    p (int to,int c): to(to), c(c) {}
    int get_ (int x) {
        return (x - to) * (x - to) + c;
    }
};

vector <p> tree;
vector <int> x;
int get_pos (int val) {
    return lower_bound(x.begin(),x.end(),val) - x.begin();
}
void update (int i,int l,int r,p val) {
    int m = (l + r) / 2;
    if (tree[i].get_(x[m]) > val.get_(x[m])) {
        swap(tree[i],val);
    }
    if (r - l == 1) {
        return ;
    }
    if (tree[i].get_(x[l]) > val.get_(x[l])) {
        update(2 * i + 1,l,m,val);
    } else {
        update (2 * i + 2,m,r,val);
    }
}

int mn (int i,int l,int r,int pos) {
    if (pos < l || r <= pos) {
        return INF;
    }
    if (r - l == 1) {
        return tree[i].get_(x[pos]);
    }
    int m = (l + r) / 2;
    return min(min(tree[i].get_(x[pos]),mn(2 * i + 1,l,m,pos)),mn(2 * i + 2,m,r,pos));
}



void solve() {
    ll n,f,c;
    cin >> n >> f >> c;
    vector < pair <ll,ll> > a(n);
    set <ll> st;
    for (int i = 0;i < n;i++) {
        cin >> a[i].first >> a[i].second;
        st.insert(a[i].first);
    }
    for (auto y: st) {
        x.push_back(y);
    }
    ll m = x.size();
    tree = vector <p> (4 * m);
    vector <int> dp(n + 1);
    dp[0] = 0;
    update(0,0,n,p(0,0));
    for (int i = 1;i <= n;i++) {
        dp[i] = mn(0,0,n,get_pos((int)a[i - 1].first)) + (int)a[i - 1].second * (int)c;
        update(0,0,n,p(a[i - 1].first,dp[i]));
        //cout << (ll)dp[i] << " ";
    }
    long double ans = (long double)f * (long double)f / (long double)c;
    for (int i = 1;i <= n;i++) {
        int g = __gcd((ll)dp[i],(ll)c);
        dp[i] /= g;
        int c1 = c / g;
        long double t = (long double)dp[i] / (long double)c1;
        if (t < 0.0) {
            continue;
        }
        t += ((long double)f - (long double)a[i - 1].first) * ((long double)f - (long double)a[i - 1].first) / (long double)c;
        ans = min(ans,t);
    }
    cout << fixed << setprecision (12) << ans;


}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    //nb = {1,2,3,5,5,6};
    //cout << get_b_r(7,5).first << " " << get_b_r(7,5).second;
    return 0;
}
