#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;
template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define F first
#define ve vector
#define S second
#define int ll
#define debug(x) cout << "DEBUG " << (#x) << " = " << x << '\n';

template<class T>
istream &operator>>(istream &in, ve<T> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class T>
ostream &operator<<(ostream &out, ve<T> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}
ve<int> x;
struct LCT {
    struct func {
        int a, b;
        int calc(int i) {
            return (a-x[i])*(a-x[i]) + b;
        }
    };
    ve<func> t;
    int n;
    void add_line(int v, int l, int r, func nw) {
        func old = t[v];
        int m = (l + r)/2;
        if (nw.calc(m) < old.calc(m))
            swap(old, nw);
        t[v] = old;
        if (nw.calc(l) <= old.calc(l))
            add_line(2*v+1, l, m, nw);
        else if (nw.calc(r-1) <= old.calc(r-1))
            add_line(2*v+2, m, r, nw);
        // не уверен нефига
    }
    void add_line(int a, int b) {
        add_line(0, 0, n, {a, b});
    }

    int get(int v, int l, int r, int i) {
        if (l + 1 == r)
            return t[v].calc(i);
        int m = (l + r)/2;
        if (i < m)
            return min(t[v].calc(i), get(2*v+1, l, m, i));
        else
            return min(t[v].calc(i), get(2*v+2, m, r, i));
    }
    int get(int i) {
        return get(0, 0, n, i);
    }

    LCT (int _n) {
        n = _n;
        t.assign(4*n, {0, (int)1e18});
    }
};

int32_t main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    cout.setf(ios::fixed);
    cout.precision(10);

    int n, m, c;
    cin >> n >> m >> c;
    ve<int> dp(n + 2, 0), T(n+2, 0);
    x.assign(n + 2, 0);
    x[n+1] = m;
    dp[n+1] = 0;
    for (int i = 1; i <= n; ++i)
        cin >> x[i] >> T[i];
    LCT t(n+2);
    t.add_line(x[n+1], dp[n+1] + T[n + 1]);
    for (int i = n; i >= 0; --i) {
        dp[i] = t.get(i);
        t.add_line(x[i], dp[i] + c*T[i]);
    }
    cout << dp[0]/ld(c);
}