#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;
template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define F first
#define ve vector
#define S second
#define debug(x) cout << "DEBUG " << (#x) << " = " << x << '\n';

template<class T>
istream &operator>>(istream &in, ve<T> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class T>
ostream &operator<<(ostream &out, ve<T> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int32_t main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    ll n;
    cin >> n;
    pair<ll, ll> a[n];
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    for (ll i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    for(ll i = 0; i < n; i++){
        if(a[i].first > a[i].second)
            swap(a[i].first, a[i].second);
    }
    sort(a, a + n);
    ll i;
    for(i = 0; i < n - 1; i++){
        if(a[i].second > a[i + 1].second){
            cout << -1;
            return 0;
        }
    }
    for(ll i = 0; i < n; i++){
        cout << a[i].first << " ";
    }
    cout << endl;
    for(i = 0; i < n; i++){
        cout << a[i].second << " ";
    }
}