#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;
template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define F first
#define ve vector
#define S second
#define debug(x) cout << "DEBUG " << (#x) << " = " << x << '\n';

template<class T>
istream &operator>>(istream &in, ve<T> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class T>
ostream &operator<<(ostream &out, ve<T> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int32_t main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    ll S = abs((x2-x1)*(y3-y1) - (y2-y1)*(x3-x1));
    auto dist = [&](ll x1, ll y1, ll x2, ll y2) -> ll {
        return (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2);
    };
    ll x = max({dist(x1, y1, x2, y2), dist(x1, y1, x3, y3), dist(x2, y2, x3, y3)});
    if (dist(x1, y1, x2, y2) == x) {
        cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2;
    }
    else if (dist(x1, y1, x3, y3) == x) {
        cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3;
    } else {
        cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3;
    }
}
