#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

void solve();

#define int long long
#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define vi vector<ll>
#define vii vector<vi>
#define vip vector<pair<ll, ll>>
#define viip vector<vip>
#define double long double
const int N = 3e5 + 10, MOD = 1e9 + 7;
const int INF = 1e8;
const double EPS = 1e-9, pi = acos(-1);

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

struct line {
    double k = 0;
    double b = INF;

    double get(double x) {
        return k * x + b;
    }
};

vector<line> t;

void upd(int v, int l, int r, line L) {
    if (l > r) return;
    int m = (l + r) / 2;
    bool M = L.get(m) < t[v].get(m);
    bool tl = L.get(l) < t[v].get(l);
    if (M) {
        swap(L, t[v]);
    }
    if (M != tl) {
        upd(v * 2, l, m - 1, L);
    } else {
        upd(v * 2 + 1, m + 1, r, L);
    }
}

double get(int v, int l, int r, double x) {
    if (l > r) return INF;
    int m = (l + r) / 2;
    if (x == m) return t[v].get(x);
    if (x < m) {
        return min(t[v].get(x), get(v * 2, l, m - 1, x));
    } else {
        return min(t[v].get(x), get(v * 2 + 1, m + 1, r, x));
    }
}

void solve() {
    int n, m, c;
    cin >> n >> m >> c;
    vector<int> x(n), ti(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> ti[i];
    }
    vector<double> dp(n);
    t.resize((m + 1) * 4);
    upd(1, 0, m, {0, 0});
    for (int i = 0; i < n; i++) {
        dp[i] = get(1, 0, m, x[i]) + (double)x[i] * x[i] / c;
        upd(1, 0, m, {-2.0 * x[i] / c, dp[i] + ti[i] + (double)x[i] * x[i] / c});
    }
    cout << fixed << setprecision(12);
    cout << get(1, 0, m, m) + (double)m * m / c;
}