#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ld = long double;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

const int N = 1e5;
multiset<int> g[N];
int used[N], col[N];
int ans = 0;

void solve() {
    int n, m;
    cin >> n >> m;
    for (int t = 0; t < m; ++t) {
        char ch;
        int v, u, c;
        cin >> ch >> v >> u >> c;
        --v, --u;
        if (ch == '+') {
            int ok = used[c];
            if (g[v].count(c) == 1) {
                used[c]++;
            }
            if (g[u].count(c) == 1) {
                used[c]++;
            }
            if (ok == 0 && used[c] != 0) {
                ans -= col[c];
            } else if (used[c] == 0) {
                ans++;
            }
            col[c]++;
            g[v].insert(c);
            g[u].insert(c);
        } else {
            int ok = used[c];
            if (g[v].count(c) == 2) {
                used[c]--;
            }
            if (g[u].count(c) == 2) {
                used[c]--;
            }
            if (ok != 0 && used[c] == 0) {
                ans += col[c] - 1;
            } else if (used[c] == 0) {
                ans--;
            }
            col[c]--;
            g[v].extract(c);
            g[u].extract(c);
        }
        cout << ans << '\n';
    }
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
