import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        TreeMap<Integer,Integer>[] q = new TreeMap[n];
        for (int i = 0;i<n;i++) {
            q[i] = new TreeMap<>();
        }
        Set<Integer> st = new TreeSet<>();
        TreeMap<Integer,Integer> ans = new TreeMap<>();
        for (int i = 0;i<m;i++) {
            String s = nextToken();
            int a = nextInt();
            int b = nextInt();
            int c = nextInt();
            st.add(c);
            a--;
            b--;
            if (s.equals("+")) {
                if (q[a].containsKey(c)) {
                    int t = q[a].get(c);
                    t++;
                    q[a].remove(c);
                    q[a].put(c,t);
                    if (ans.containsKey(c)) {
                        int r = ans.get(c);
                        r++;
                        ans.remove(c);
                        ans.put(c,r);
                    } else {
                        ans.put(c,1);
                    }
                } else {
                    q[a].put(c,1);
                }
                if (q[b].containsKey(c)) {
                    int t = q[b].get(c);
                    t++;
                    q[b].remove(c);
                    q[b].put(c,t);
                    if (ans.containsKey(c)) {
                        int r = ans.get(c);
                        r++;
                        ans.remove(c);
                        ans.put(c,r);
                    } else {
                        ans.put(c,1);
                    }
                } else {
                    q[b].put(c,1);
                }
            }
            if (s.equals("-")) {
                if (q[a].containsKey(c)) {
                    int t = q[a].get(c);
                    t--;
                    q[a].remove(c);
                    if (t>0) {
                        q[a].put(c,t);
                    }
                    if (t==1) {
                        if (ans.containsKey(c)) {
                            int y = ans.get(c);
                            y--;
                            ans.remove(c);
                            if (y>0) {
                                ans.put(c,y);
                            }
                        }
                    }
                }
                if (q[b].containsKey(c)) {
                    int t = q[b].get(c);
                    t--;
                    q[b].remove(c);
                    if (t>0) {
                        q[b].put(c,t);
                    }
                    if (t==1) {
                        if (ans.containsKey(c)) {
                            int y = ans.get(c);
                            y--;
                            ans.remove(c);
                            if (y>0) {
                                ans.put(c,y);
                            }
                        }
                    }
                }
            }
            out.println(st.size()-ans.size());
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}