#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    double c, h;
    cout << fixed << setprecision(10);
    cin >> c >> h;
    if (c >= h * 2) {
        cout << c * h / 2;
    } else {
        cout << -1;
    }
    return 0;
}
