#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m, s;
    cin >> n >> m >> s;
    if (m * n == s) {
        cout << 0;
        return 0;
    } else {
        if (s % n == 0 || s % m == 0) {
            cout << 1;
            return 0;
        } else {
            if (n > m) swap(n, m);
            for (ll i = 1; i < n; ++i) {
                if (s % i == 0) {
                    if (s / i < m) {
                        cout << 2;
                        return 0;
                    }
                }
            }
            ll t = n * m - s;
            for (ll i = 1; i < n; ++i) {
                if (t % i == 0) {
                    if (t / i < m) {
                        cout << 2;
                        return 0;
                    }
                }
            }
            for (int x = 1; x < n; ++x) {
                if (x * 2 != m) {
                    if (s - m * n + n + x != 0) {
                        if (abs(s - m * n + n * x) % abs(x * 2 - m) == 0) {
                            if ((s - m * n + n * x) / (x * 2 - m) > 0) {
                                cout << 2;
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    }
    cout << 3;
    return 0;
}