#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    long long n, m, s;
    cin >> n >> m >> s;
    if (s == n * m) {
        cout << 0;
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        cout << 1;
        return 0;
    }
    if (n > m) swap(n, m);
    for (long long x = 1; x <= n; ++x) {
        if (2 * x == n) {
            if (s == n * m - x * m) {
                cout << 2;
                return 0;
            }
        } else if ((s - n * m + x * m) % (2 * x - n) == 0) {
            long long y = (s - n * m + x * m) / (2 * x - n);
            if (y >= 0 && y <= m) {
                cout << 2;
                return 0;
            }
        }
        if (n * m == s) {
            cout << 2;
            return 0;
        }
        if ((n * m - s) % x == 0) {
            long long y = (n * m - s) / x;
            if (y >= 0 && y <= m) {
                cout << 2;
                return 0;
            }
        }
        if (s % x == 0) {
            long long y = s / x;
            if (y >= 0 && y <= m) {
                cout << 2;
                return 0;
            }
        }
    }
    cout << 3;
    return 0;
}