#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m, s;
    cin >> n >> m >> s;
    if (n > m) {
        swap(n, m);
    }
    if (n * m == s) {
        cout << 0;
    } else if (s % n == 0 || s % m == 0) {
        cout << 1;
    } else {
        for (int i = 1; i <= n; ++i) {
            if (s % i == 0 && s / i <= m) {
                cout << 2;
                return 0;
            }
        }
        ll k = n * m - s;
        for (int i = 1; i <= n; ++i) {
            if (k % i == 0 && k / i <= m) {
                cout << 2;
                return 0;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (2 * i - m == 0 && s - n * m + n * i == 0) {
                cout << 2;
                return 0;
            }
            if ((s - n * m + n * i) % (2 * i - m) == 0) {
                cout << 2;
                return 0;
            }
        }
        cout << 3;
    }
    return 0;
}