#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    cout << "0 0\n";
    cout << "0 " << n << '\n';
    cout << n << " 0\n";
    if (n % 2 == 1) {
        cout << "0 0\n";
        cout << n - 1 << ' ' << n - 1 << "\n";
        int a = 1, b = n - 2, c = 1, d = n - 1;
        int x = n - 1, y = n - 1;
        int cnt = 0;
        for (int i = 6; i <= 2 * n - 1; ++i) {
            if (cnt == 1) {
                y = a;
                a++;
            } else if (cnt == 2) {
                x = d;
                d--;
            } else if (cnt == 3) {
                y = b;
                b--;
            } else {
                x = c;
                c++;
            }
            cout << x << ' ' << y << '\n';
            cnt++;
            cnt %= 4;
        }
    } else {
        cout << "-1 0\n";
        cout << n - 1 << ' ' << n << '\n';
        int x = n - 1, y = n;
        int a = 1, b = n - 1, c = 1, d = n - 2;
        int cnt = 0;
        for (int i = 6; i <= 2 * n - 1; ++i) {
            if (cnt == 0) {
                y = a;
                a++;
            } else if (cnt == 1) {
                x = c;
                c++;
            } else if (cnt == 2) {
                y = b;
                b--;
            } else {
                x = d;
                d--;
            }
            cout << x << ' ' << y << '\n';
            cnt++;
            cnt %= 4;
        }
    }
    return 0;
}