#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    int ans = 0;
    unordered_map<int, unordered_map<int, int>> mp;
    unordered_map<int, int> d, ex;
    for (int i = 0; i < q; ++i) {
        string s;
        int v, u, c;
        cin >> s >> v >> u >> c;
        if (s[0] == '+') {
            mp[c][v]++;
            mp[c][u]++;
            if (mp[c][v] == 2) {
                ex[c]++;
                if (ex[c] == 1) {
                    ans -= d[c] / 2;
                }
            }
            if (mp[c][u] == 2) {
                ex[c]++;
                if (ex[c] == 1) {
                    ans -= d[c] / 2;
                }
            }
            if (mp[c][v] == 1) {
                d[c]++;
            }
            if (mp[c][u] == 1) {
                d[c]++;
            }
            if (ex[c] == 0 && mp[c][v] == 1 && mp[c][u] == 1) {
                ans++;
            }
        } else {
            mp[c][v]--;
            mp[c][u]--;
            if (mp[c][v] == 0) {
                d[c]--;
            }
            if (mp[c][u] == 0) {
                d[c]--;
            }
            if (mp[c][v] == 1) {
                ex[c]--;
                if (ex[c] == 0) {
                    ans += d[c] / 2;
                }
            }
            if (mp[c][u] == 1) {
                ex[c]--;
                if (ex[c] == 0) {
                    ans += d[c] / 2;
                }
            }
            if (ex[c] == 0 && mp[c][v] == 0 && mp[c][u] == 0) {
                ans--;
            }
        }
        cout << ans << "\n";
    }
    return 0;
}