#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    if (n == 1) {
        cout << "1";
    } else if (n == 2 || n == 3 || n == 4) {
        cout << -1;
    } else if (n == 5) {
        cout << "4 4 2 2 2\n"
                "4 4 4 2 3\n"
                "5 5 1 2 3\n"
                "5 1 1 3 3\n"
                "5 5 1 1 3";
    }else {
        vector<vector<int>> a(n);
        for (int i = 0; i < n; ++i) {
            a[i].resize(n);
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                a[i][j] = n;
            }
        }
        int cnt = n;
        int col = 1;
        for (int i = 0; i < n - 1; ++i) {
            for (int j = 0; j < cnt; ++j) {
                a[i][j] = col;
            }
            for (int j = cnt - 1; j < n - 1; ++j) {
                a[i + 1][j] = col;
            }
            cnt--;
            col++;
        }
        a[n - 1][0] = n - 1;
        a[n - 1][n - 2] = n;
        a[1][0] = 3;
        a[1][n - 1] = 2;
        a[3][n - 2] = n;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                cout << a[i][j] << ' ';
            }
            cout << '\n';
        }
    }
    return 0;
}