#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    pnt a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    ll f = len(a-b);
    ll s = len(a-c);
    ll t = len(b-c);
    if (f>s&&f>t){
        cout<<a<<" "<<b;
    }else if(s>f&&s>t){
        cout<<a<<" "<<c;
    }else{
        cout<<b<<" "<<c;
    }
        return 0;
}
