//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx, avx2, bmi2,fma")

#include <bits/stdc++.h>

using namespace std;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}


#define int long long
#define ld long double
constexpr int MAXN = 2e5, INF = 2e9, MOD = 1e9 + 7;
const ld EPS = 1e-12;

int get(int n, int m, int s) {
    if (n * m == s) {
        return 0;
    }
    if (s % m == 0 || s % n == 0) {
        return 1;
    }
    int l = 0, r = n;
    while (r - l > 1){
        int mid = (r+l)/2;
        if (mid * m > s) {
            r = mid;
        } else{
            l = mid;
        }
    }
    s -= l * m;
    if (s%(n-l)==0){
        return 2;
    }
    return 3;
}
void solve() {
    int n,m,s;
    cin >> n >>m>>s;
    cout<< min(get(n,m,s), get(m,n,s));
}