//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx, avx2, bmi2,fma")

#include <bits/stdc++.h>

using namespace std;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}


#define int long long
#define ld long double
constexpr int MAXN = 3e5, INF = 2e9, MOD = 1e9 + 7;
const ld EPS = 1e-12;

struct Line{
    ld k,b;
    ld get(int x) {
        return k * x + b;
    }
};

int xx[MAXN];
Line tree[MAXN * 4];

void add(int t, int tl, int tr, Line l) {
    if (tl > tr) {
        return;
    }
    int m = (tl + tr)/2;
    bool bl = l.get(xx[tr]) < tree[t].get(xx[tr]);
    bool bm = l.get(xx[m]) < tree[t].get(xx[m]);
    if (bm) {
        swap(l, tree[t]);
    }
    if (bm != bl) {
        add(t * 2 + 1,m+1,tr,l);
    } else {
        add(t * 2,tl, m-1,l);
    }
}

ld gett(int t, int l, int r, int x) {
    if (l > r) return INF;
    int m = (l + r) / 2;
    if (x == m) {
        return tree[t].get(xx[x]);
    }
    if (x < m) {
        return min(tree[t].get(xx[x]), gett(t * 2,l,m-1,x));
    } else {
        return min(tree[t].get(xx[x]), gett(t * 2 + 1,m+1,r,x));
    }
}


void solve() {
    int n;
    cin >> n;
    int m;
    cin >> m;
    int c;
    cin >> c;
    vector<int>t(n);
    for (int i = 0; i < n; i++) {
        cin >> xx[i];
        cin >> t[i];
    }
    xx[n]=m;
    map<int,int> mp;
    for (int i = 0; i <= n; i++){
        mp[xx[i]]=i;
    }

    for (int i = 1; i < n * 4; i++) {
        tree[i] ={0, 0};
    }
    vector<ld>dp(n+1);
    for (int i = 0; i <= n; i++) {
        auto mn = gett(1,0,n,mp[xx[i]]) + (ld)xx[i] * xx[i] / c;
        dp[i]= mn;
        add(1,0,n,{-2 * (ld)xx[i] / c, (ld)dp[i] + (ld)xx[i] * xx[i] / c + t[i]});
    }
    cout << fixed << setprecision(12);
    cout << dp[n];
}