//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx, avx2, bmi2,fma")

#include <bits/stdc++.h>

using namespace std;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}


#define int long long
#define ld long double
constexpr int MAXN = 2e5, INF = 2e9, MOD = 1e9 + 7;
const ld EPS = 1e-12;

struct Point {
    ld x, y;

    Point(ld x, ld y) : x(x), y(y) {}

    Point() : x(0), y(0) {}
};

struct Line {
    ld a, b, c;

    Line(Point x, Point y) {
        a = x.y - y.y;
        b = y.x - x.x;
        c = (x.x * y.y - y.x * x.y);
    }

    ld pl(Point p) const {
        return abs((a * p.x + b * p.y + c)) / sqrt(a * a + b * b);
    }
};

void solve() {
    Point a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    if (abs(Line(a, b).pl(c) - min({Line(a, c).pl(b), Line(a, b).pl(c), Line(b, c).pl(a)})) <= EPS) {
        cout << a.x << ' ' << a.y << ' ' << b.x << ' ' << b.y << '\n';
    } else if (abs(Line(b, c).pl(a) - min({Line(a, c).pl(b), Line(a, b).pl(c), Line(b, c).pl(a)})) <= EPS) {
        cout << b.x << ' ' << b.y << ' ' << c.x << ' ' << c.y << '\n';
    } else {
        cout << a.x << ' ' << a.y << ' ' << c.x << ' ' << c.y << '\n';
    }
}