import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        long n = nextLong();
        String s = nextToken();
        char[] a = s.toCharArray();
        String t = "";
        for (int i = 0; i < s.length(); i++) {
            if(a[i] != '0') {
                t = s.substring(i);
                break;
            }
        }
        long x = Long.parseLong(t);
        long y = (long)Math.pow(10, n);
        while(x % 2 == 0 && y % 2 == 0) {
            x /= 2;
            y /= 2;
        }
        while(x % 5 == 0 && y % 5 == 0) {
            x /= 5;
            y /= 5;
        }
        if(0 < x && x < y && y < 1e6) {
            out.println("YES");
            out.println(x + " " + y);
        } else {
            out.println("NO");
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}