import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        double x1 = nextDouble();
        double y1 = nextDouble();
        double x2 = nextDouble();
        double y2 = nextDouble();
        double x3 = nextDouble();
        double y3 = nextDouble();
        double l12 = Math.sqrt(Math.pow(Math.abs(x2 - x1), 2) + Math.pow(Math.abs(y2-y1), 2));
        double l13 = Math.sqrt(Math.pow(Math.abs(x3 - x1), 2) + Math.pow(Math.abs(y3-y1), 2));
        double l23 = Math.sqrt(Math.pow(Math.abs(x2 - x3), 2) + Math.pow(Math.abs(y2-y3), 2));
        double p = (l12 + l13 + l23) / 2;
        double s = Math.sqrt(p * (p - l12) * (p - l13) * (p-l23));
        double h1 = s*2/l23;
        double h2 = s*2/l13;
        double h3 = s*2/l12;
        double min = Math.min(Math.min(h1, h2), h3);
        if(min == h1) {
            out.println((long)x2 + " " + (long)y2 + " " + (long)x3 + " " + (long)y3);
        } else if(min == h2) {
            out.println((long)x1 + " " + (long)y1 + " " + (long)x3 + " " + (long)y3);
        } else {
            out.println((long)x2 + " " + (long)y2 + " " + (long)x1 + " " + (long)y1);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}