/*#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,fma,tune=native")
*/
#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define double long double
#define F first
#define S second
using namespace std;
const double inf = 1e18;

struct line {
    double k, b;

    double operator()(double x) {
        return k * x + b;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    double c;
    cin >> n >> m >> c;
    vector<double> x(n + 2), t(n + 2);
    for (int i = 1; i < n + 1; ++i) {
        cin >> x[i] >> t[i];
    }
    x[0] = 0, t[0] = 0;
    x[n + 1] = m, t[n + 1] = 0;
    vector<double> dp(n + 2, LLONG_MAX);
    dp[0] = 0;
    vector<pair<double, line>> cht = {{-inf, {-2 * x[0] / c, x[0] * x[0] / c}}};
    for (int i = 1; i < n + 2; ++i) {
        double co = t[i] + x[i] * x[i] / c;
        int l = 0, r = (int) cht.size();
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (cht[mid].F <= x[i]) {
                l = mid;
            } else {
                r = mid;
            }
        }
        dp[i] = co + cht[l].S(x[i]);
        double k = -2 * x[i] / c;
        double b = dp[i] + x[i] * x[i] / c;
        double dx;
        while (!cht.empty()) {
            dx = (b - cht.back().S.b) / (-k + cht.back().S.k);
            if (dx < cht.back().F) {
                cht.pop_back();
            } else {
                break;
            }
        }
        cht.push_back({dx, {k, b}});
    }
    cout << fixed << setprecision(10) << dp[n + 1];
    return 0;
}
