#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC target("arch=sandybridge")

#define int long long
#define all(x) x.begin(),x.end()

void solve();

void solve1();

void solve2();

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
using multiordered_set = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    //cin >> q;
    while (q--) {
        solve2();
    }
}

bool is_zero(int n, int m, int s) {
    return n * m == s;
}

bool is_one(int n, int m, int s) {
    for (int i = 1; i <= m; i++) {
        if (i * n == s) return 1;
    }
    for (int i = 1; i <= n; i++) {
        if (i * m == s) return 1;
    }
    return 0;
}

bool is_two(int n, int m, int s) {
    for (int x = 1; x <= m; x++) {
        int y = (n * m - s) / x;
        if ((n * m - s) % x == 0 && y > 0 && y <= n) return 1;
    }
    for (int x = 1; x < m; x++) {
        int y = s + x * n - n * m;
        if (2 * x == m) {
            if (x * n == s) return 1;
            continue;
        }
        if (y % (2 * x - m) != 0) continue;
        y /= (2 * x - m);
        if (y > 0 && y <= n) return 1;
    }
    return 0;
}

void solve2() {
    int n, m, s;
    cin >> n >> m >> s;
    if (is_zero(n, m, s)) {
        cout << 0;
        return;
    }
    if (is_one(n, m, s)) {
        cout << 1;
        return;
    }
    if (is_two(n, m, s)) {
        cout << 2;
        return;
    }
    cout << 3;
}