#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC target("arch=sandybridge")

#define int long long
#define all(x) x.begin(),x.end()

void solve();

void solve1();

void solve2();

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
using multiordered_set = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

signed main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    ll q = 1;
    //cin >> q;
    while (q--) {
        solve2();
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<map<ll, ll>> ed(n);
    vector<ll> col_ed(1e5 + 1);
    vector<ll> col_bad(1e5 + 1);
    ll answer = 0;
    while (m--) {
        char q;
        ll a, b, c;
        cin >> q >> a >> b >> c;
        a--, b--;
        if (q == '+') {
            if (col_bad[c] == 0) {
                answer -= col_ed[c];
            }
            if (ed[a][c] == 1) {
                col_bad[c]++;
            }
            ed[a][c]++;
            if (ed[b][c] == 1) {
                col_bad[c]++;
            }
            ed[b][c]++;
            col_ed[c]++;
            if (col_bad[c] == 0) {
                answer += col_ed[c];
            }
        } else {
            if (col_bad[c] == 0) {
                answer -= col_ed[c];
            }
            col_ed[c]--;
            ed[a][c]--;
            ed[b][c]--;
            if (ed[a][c] == 1) {
                col_bad[c]--;
            }
            if (ed[b][c] == 1) {
                col_bad[c]--;
            }
            if (col_bad[c] == 0) {
                answer += col_ed[c];
            }
        }
        cout << answer << '\n';
    }
}

struct line {
    ld a, b, c;
};

struct point {
    ld x, y;
};

line get(point p1, point p2) {
    ld a = p1.y - p2.y;
    ld b = p2.x - p1.x;
    ld c = p1.x * p2.y - p2.x * p1.y;
    return {a, b, c};
}

ld dist(line l, point p) {
    return abs((l.a * p.x + l.b * p.y + l.c) / hypotl(l.a, l.b));
}

void solve1() {
    point a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    line aa = get(b, c);
    line bb = get(a, c);
    line cc = get(a, b);
    ld fir = dist(aa, a);
    ld sec = dist(bb, b);
    ld thr = dist(cc, c);
    if (fir <= sec && fir <= thr) {
        cout << b.x << ' ' << b.y << ' ' << c.x << ' ' << c.y;
        return;
    }
    if (sec <= fir && sec <= thr) {
        cout << a.x << ' ' << a.y << ' ' << c.x << ' ' << c.y;
        return;
    }
    if (thr <= sec && thr <= fir) {
        cout << b.x << ' ' << b.y << ' ' << a.x << ' ' << a.y;
        return;
    }
}

char que(int y, int y1) {
    cout << "? " << y << " " << y1 << endl;
    char f;
    cin >> f;
    return f;
}

void solve2() {
    int l = 0;
    int r = 8;
    int e = 0;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (que(m - e, m - e) == '+') {
            l = m;
            e = m;
        } else {
            r = m;
        }
    }
    int u = l;
    l = 0;
    r = 8;
    e = 0;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (que(-(m - e), -(m - e)) == '+') {
            l = m;
            e = m;
        } else {
            r = m;
        }
    }
    if (l == 7) {
        cout << "! " <<char( 'a' + l - u) << 8 - u;
        exit(0);
    } else {
        string f = (char) ('a' + l - u) + to_string((8) - u);
        string f1 = (char) ('a' + 8 - u-1) + to_string(l - u + 1);
        if(que(-1,1)=='-'){
            cout<<f;
        }
        else{
            cout<<f1;
        }
    }
}