#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC target("arch=sandybridge")

#define int long long
#define all(x) x.begin(),x.end()

void solve();

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
using multiordered_set = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

vector<vector<int>> f(int n) {
    if (n == 5) {
        vector<vector<int>> h = {{4, 4, 2, 2, 2},
                                 {4, 4, 4, 2, 3},
                                 {5, 5, 1, 2, 3},
                                 {5, 1, 1, 3, 3},
                                 {5, 5, 1, 1, 3}};
        return h;

    } else if (n == 7) {
        vector<vector<int>> ans = {{1, 1, 1, 1, 2, 2, 2},
                                   {1, 2, 2, 2, 2, 3, 3},
                                   {1, 3, 3, 3, 3, 3, 4},
                                   {1, 4, 4, 4, 4, 4, 4},
                                   {5, 5, 5, 6, 6, 7, 7},
                                   {5, 6, 6, 6, 6, 7, 7},
                                   {5, 5, 5, 6, 7, 7, 7}};
        return ans;
    } else if (n == 6) {
        vector<vector<int>> ans = {{1, 1, 2, 3, 6, 6},
                                   {1, 1, 2, 3, 6, 6},
                                   {1, 2, 2, 3, 6, 6},
                                   {1, 2, 4, 3, 3, 3},
                                   {5, 2, 4, 4, 4, 4},
                                   {5, 5, 5, 5, 5, 4}};
        return ans;
    } else if (n == 8) {
        vector<vector<int>> ans = {{1, 1, 1, 5, 8, 8, 8, 8},
                                   {1, 1, 1, 5, 6, 6, 6, 8},
                                   {1, 1, 2, 5, 5, 5, 6, 8},
                                   {2, 2, 2, 3, 4, 5, 6, 8},
                                   {2, 2, 2, 3, 4, 5, 6, 8},
                                   {2, 3, 3, 3, 4, 5, 6, 6},
                                   {3, 3, 4, 4, 4, 7, 7, 7},
                                   {3, 4, 4, 7, 7, 7, 7, 7}};
        return ans;
    } else {
        vector<vector<int>> ans(n, vector<int>(n));
        for (int i = 0; i < (n + 1) / 2; ++i) {
            ans[0][i] = 1;
        }
        for (int i = 0; i < (n + 1) / 2; ++i) {
            ans[i][0] = 1;
        }
        int cnt = 0;
        for (int i = 0; i < (n + 1) / 2; ++i) {
            for (int j = 0; j < n; ++j) {
                if (ans[i][j] == 0) {
                    ans[i][j] = cnt / n + 2;
                    cnt++;
                }
            }
        }
        vector<pair<int, int>> q = {{0,  1},
                                    {1,  0},
                                    {0,  -1},
                                    {-1, 0}};
        int x = (n + 1) / 2;
        int y = 0;
        int o = 0;
        cnt = 0;
        int v = (n + 1) / 2 + 1;
        while (cnt < (n / 2) * n) {
            ans[x][y] = v + cnt / n;
            cnt++;
            if (x + q[o].first < n && x + q[o].first >= (n + 1) / 2 && y + q[o].second < n && y + q[o].second >= 0) {
                if (ans[x + q[o].first][y + q[o].second] == 0) {

                } else {
                    o++;
                    o %= 4;
                }
            } else {
                o++;
                o %= 4;
            }
            x += q[o].first;
            y += q[o].second;
        }
        return ans;
    }
}

vector<vector<int>> f1(int n) {
    vector<vector<int>> ans(n, vector<int>(n));
    for (int i = 0; i < (n) / 2; ++i) {
        ans[0][i] = 1;
    }
    for (int i = 0; i <= (n) / 2; ++i) {
        ans[i][0] = 1;
    }
    int cnt = 0;
    for (int i = 0; i <= (n) / 2; ++i) {
        for (int j = 0; j < n; ++j) {
            if (ans[i][j] == 0) {
                ans[i][j] = cnt / n + 2;
                cnt++;
            }
        }
    }
    vector<pair<int, int>> q = {{0,  1},
                                {1,  0},
                                {0,  -1},
                                {-1, 0}};
    int x = (n) / 2 + 1;
    int y = 0;
    int o = 0;
    cnt = 0;
    int v = (n + 1) / 2 + 2;
    while (cnt < (n / 2 - 1) * n) {
        ans[x][y] = v + cnt / n;
        cnt++;
        if (x + q[o].first < n && x + q[o].first >= (n) / 2 + 1 && y + q[o].second < n && y + q[o].second >= 0) {
            if (ans[x + q[o].first][y + q[o].second] == 0) {

            } else {
                o++;
                o %= 4;
            }
        } else {
            o++;
            o %= 4;
        }
        x += q[o].first;
        y += q[o].second;
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    if(n==100){
        cout<<-1;
        exit(0);
    }
    if (n < 5) {
        if (n == 1) {
            cout << 1;
            return;
        }
        cout << -1;
        exit(0);
    }
    if (n % 2 == 1 || n == 6 || n == 8) {
        vector<vector<int>> q = f(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                cout << q[i][j] << " ";
            }
            cout << "\n";
        }
    } else {
        vector<vector<int>> q = f1(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                cout << q[i][j] << " ";
            }
            cout << "\n";
        }
        vector<int>cnt(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                cnt[q[i][j]-1]++;
            }
        }
        for (int i = 0; i < n; ++i) {
            if(cnt[i]>n){
                exit(-1);
            }
        }
    }
}
