#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC target("arch=sandybridge")

#define int long long
#define all(x) x.begin(),x.end()

void solve();

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
using multiordered_set = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

ll get(ll x1, ll y1, ll x2, ll y2) {
    return (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
}

void solve() {
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    ll u = get(x1, y1, x2, y2);
    ll u1 = get(x1, y1, x3, y3);
    ll u2 = get(x2, y2, x3, y3);
    if (u >= u1 && u >= u2) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2;
    } else if (u1 >= u && u1 >= u2) {
        cout << x1 << " " << y1 << " " << x3 << " " << y3;
    } else if (u2 >= u && u2 >= u1) {
        cout << x3 << " " << y3 << " " << x2 << " " << y2;
    }
}
