#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    map<int, int> c;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    for (int i = 0; i < n; i++) {
        if (b[i] <= a[i]) {
            swap(b[i], a[i]);
        }
    }
    vector<vector<int>> array(n, vector<int>(2));
    for (int i = 0; i < n; i++) {
        array[i][0] = a[i];
        array[i][1] = b[i];
    }
    sort(array.begin(), array.end(), [](vector<int> f, vector<int> s) {
        if (f[0] == s[0]) {
            return f[1] < s[1];
        }
        return f[0] < s[0];
    });

    bool flag = true;
    for (int i = 0; i < n - 1; i++) {
        if (array[i][1] > array[i + 1][1]) {
            cout << -1;
            flag = false;
            break;
        }
    }
    if (flag) {
        for (int i = 0; i < n; i++) {
            cout << array[i][0] << " ";
        }
        cout << endl;
        for (int i = 0; i < n; i++) {
            cout << array[i][1] << " ";
        }
    }
    return 0;
}