#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int C = 1e5 + 1;

int cnt[C];
int bad[C];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    int sumGood = 0;

    vector<map<int, int>> adj(n);
    auto tog = [&](int c, int t) {
        if (!bad[c]) {
            sumGood -= cnt[c];
        }
        bad[c] += t;
        if (!bad[c]) {
            sumGood += cnt[c];
        }
    };
    auto modify = [&](int v, int c, int mod) -> void {
        tog(c, -int(adj[v][c] > 1));
        adj[v][c] += mod;
        tog(c, (adj[v][c] > 1));
    };

    auto add = [&](int u, int v, int c) {
        cnt[c] += 1;
        if (!bad[c]) {
            sumGood += 1;
        }
        modify(u, c, 1);
        modify(v, c, 1);
    };


    auto del = [&](int u, int v, int c) {
        cnt[c] -= 1;
        if (!bad[c]) {
            sumGood -= 1;
        }
        modify(u, c, -1);
        modify(v, c, -1);
    };

    while (q--) {
        char type;
        int u, v, c;
        cin >> type >> u >> v >> c;
        --u, --v;
        if (type == '+') {
            add(u, v, c);
        } else {
            del(u, v, c);
        }
        cout << sumGood << '\n';
    }

    return 0;
}
