#include <bits/stdc++.h>

using namespace std;
using ll = long long;

map<pair<int, int>, char> ans;

char ask(int x, int y) {
    if (ans.find({x, y}) != ans.end()) return ans[{x, y}];
    cout << "? " << x << " " << y << endl;
    cout.flush();
    char type;
    cin >> type;
    ans[{x, y}] = type;
    return type;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int x = -1, y = -1;
    if (ask(1, 1) == '-') {
        if (ask(1, -1) == '-') x = 8;
        if (ask(-1, 1) == '-') y = 8;
        if (x != 8) {
            int l = 1, r = 8;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (ask(mid, -1) == '+') l = mid;
                else r = mid;
            }
            x = 8 - l;
        }
        if (y != 8) {
            int l = 1, r = 8;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (ask(-1, mid) == '+') l = mid;
                else r = mid;
            }
            y = 8 - l;
        }
    } else {
        int l = 1, r = 8;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (ask(mid, 1) == '+') l = mid;
            else r = mid;
        }
        x = 8 - l;
        l = 1, r = 8;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (ask(1, mid) == '+') l = mid;
            else r = mid;
        }
        y = 8 - l;
    }
    cout << "! " << char('a' + x - 1) << y << endl;
    cout.flush();
    return 0;
}
