#include <bits/stdc++.h>

using namespace std;
using ll = long long;

map<pair<int, int>, char> ans;

char ask(int x, int y) {
    if (ans.find({x, y}) != ans.end()) return ans[{x, y}];
    cout << "? " << x << " " << y << endl;
    cout.flush();
    char type;
    cin >> type;
    ans[{x, y}] = type;
    return type;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int l = 0, r = 8;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (ask(mid, mid) == '+') l = mid;
        else r = mid;
    }
    int upper = l;
    l = 0, r = 8;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (ask(-mid, -mid) == '+') l = mid;
        else r = mid;
    }
    int lower = l;
    int x1 = 1 + lower, y1 = 8 - upper;
    int x2 = 8 - upper, y2 = 1 + lower;
    if (x1 == x2 && y1 == y2) {
        cout << "! " << char('a' + x2 - 1) << y2 << endl;
        cout.flush();
        return 0;
    }
    if (ask(min(8 - x1, y1 - 1), -min(8 - x1, y1 - 1)) == '-')
        cout << "! " << char('a' + x2 - 1) << y2 << endl;
    else
        cout << "! " << char('a' + x1 - 1) << y1 << endl;
    cout.flush();
    return 0;
}
