#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double
using ll = long long;

struct node {
    double t;
    double x;
};

double eps = 1e-6;
void solve() {
    ll n, m, c;
    cin >> n >> m >> c;
    vector<node> q;
    q.push_back({0, 0});
    ll p = 0;
    auto f = [&](node u, ll x) -> double {
        return u.t + (double)(x - u.x) * (x - u.x) / c;
    };
    for (int i = 0; i < n; ++i) {
        ll x, t_plus;
        cin >> x >> t_plus;
        while (p < (ll) q.size() - 1 && f(q[p], x) + eps >= f(q[p + 1], x)) {
            p++;
        }
        p = min(p, (ll) q.size() - 1);
        double t_dp = f(q[p], x) + t_plus;
        while (!q.empty() && t_dp <= f(q.back(), x) + eps) {
            q.pop_back();
        }
        q.push_back({t_dp, (double) x});
    }
    while (p < (ll) q.size() - 1 && f(q[p], m) + eps >= f(q[p + 1], m)) {
        p++;
    }
    p = min(p, (ll) q.size() - 1);
    cout << fixed << setprecision(20) << f(q[p], m);
}

signed main() {
    long long t = 1ll;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0ll;
}