#include <bits/stdc++.h>
using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    map<int, map<int, int>> m; // таблица всех вершин
    map<int, int> r; // кол-во ребер цвета c
    map<int, int> ipf; // таблица неидеальных вершин цвета c

    char act;
    int v, u, c, temp;
    int ans = 0;

    for (int i = 0; i < q; i++) {
        cin >> act >> v >> u >> c;

        if (act == '+') {
            m[v][c]++;
            m[u][c]++;
            r[c]++;
            
            if (m[v][c] == 1 && m[u][c] == 1) { // новое идеальное ребро
                if (r[c] == 1) ans++; // больше нет ребер такого цвета
            } else { // новое неидеальное ребро (соединено с вершинами, одна из которых уже соединена с ребром этого же цвета)
                if (ipf[c] == 0) ans--;
                if (m[v][c] > 1) ipf[c]++;
                if (m[u][c] > 1) ipf[c]++;
            }
        } else {
            m[v][c]--;
            m[u][c]--;
            r[c]--;

            if (m[v][c] == 0 && m[u][c] == 0) { // убраное ребро было идеальным
                if (r[c] == 0) ans--; // этот цвет был идеальным и это последнее ребро того идеального цвета
            } else {
                if (m[v][c] > 0) ipf[c]--;
                if (m[u][c] > 0) ipf[c]--;
                if (ipf[c] == 0) ans++; // цвет стал идеальным
            }
        }

        cout << ans << "\n";
    }

    return 0;
}