#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int64_t n, q;
    cin >> n >> q;
    array<int, (int)1e5> cnt;
    array<int, (int)1e5> nonperfect_viewer;
    fill(cnt.begin(), cnt.end(), 0);
    fill(nonperfect_viewer.begin(), nonperfect_viewer.end(), 0);
    vector<unordered_map<int, int>> edge_cnt(n);
    int answer = 0;
    for (int _ = 0; _ < q; _++)
    {
        char t;
        int u, v, c;
        cin >> t >> u >> v >> c;
        u--;
        v--;
        c--;
        bool was_perfect = !nonperfect_viewer[c];
        if (t == '+'){
            cnt[c]++;
            if (!nonperfect_viewer[c])
                answer++;
            edge_cnt[u][c]++;
            if (edge_cnt[u][c] == 2){
                nonperfect_viewer[c]++;
            }
            edge_cnt[v][c]++;
            if (edge_cnt[v][c] == 2){
                nonperfect_viewer[c]++;
            }
        }
        else{
            cnt[c]--;
            if (!nonperfect_viewer[c])
                answer--;
            edge_cnt[u][c]--;
            if (edge_cnt[u][c] == 1){
                nonperfect_viewer[c]--;
            }
            edge_cnt[v][c]--;
            if (edge_cnt[v][c] == 1){
                nonperfect_viewer[c]--;
            }
        }
        bool is_perfect = !nonperfect_viewer[c];
        if (was_perfect && !is_perfect)
            answer -= cnt[c];
        if (!was_perfect && is_perfect)
            answer += cnt[c];
        cout << answer << '\n';
    }
    
}