#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;
template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define F first
#define ve vector
#define S second
#define debug(x) cout << "DEBUG " << (#x) << " = " << x << '\n';

template<class T>
istream &operator>>(istream &in, ve<T> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class T>
ostream &operator<<(ostream &out, ve<T> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int32_t main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, q;
    cin >> n >> q;
    ve<map<int, int>> mp(n);
    ve<int> bad(1e5 + 1, 0);
    ve<int> cnt(1e5 + 1, 0);
    int ans = 0;
    while (q--) {
        char type;
        int u, v, c;
        cin >> type >> u >> v >> c;
        u--;v--;
        if (type == '+') {
            cnt[c]++;
            if (mp[u][c] == 1) {
                bad[c]++;
                if (bad[c] == 1)
                    ans -= cnt[c] - 1;
            }
            mp[u][c]++;
            if (mp[v][c] == 1) {
                bad[c]++;
                if (bad[c] == 1)
                    ans -= cnt[c] - 1;
            }
            mp[v][c]++;
            if (bad[c] == 0)
                ans++;
        } else {
            cnt[c]--;
            if (mp[u][c] == 2) {
                bad[c]--;
                if (bad[c] == 0)
                    ans += cnt[c] + 1;
            }
            mp[u][c]--;
            if (mp[v][c] == 2) {
                bad[c]--;
                if (bad[c] == 0)
                    ans += cnt[c] + 1;
            }
            mp[v][c]--;
            if (bad[c] == 0)
                ans--;
        }
        cout << ans << '\n';
    }
}