#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;
template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define F first
#define ve vector
#define S second
#define int ll
#define debug(x) cout << "DEBUG " << (#x) << " = " << x << '\n';

ld pi = acos(-1);

template<class T>
istream &operator>>(istream &in, ve<T> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class T>
ostream &operator<<(ostream &out, ve<T> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}
int32_t main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n;
    cin >> n;
    if (n == 1) {
        cout << 1;
        return 0;
    }
    if (n < 5) {
        cout << -1;
        return 0;
    }
    if (n == 5) {
        cout << "4 4 2 2 2\n4 4 4 2 3\n5 5 1 2 3\n5 1 1 3 3\n5 5 1 1 3";
        return 0;
    }
    if (n == 6) {
        cout << "1 3 3 3 3 3\n1 2 5 5 3 4\n1 2 5 5 5 4\n1 2 5 6 4 4\n1 2 6 6 6 4\n1 2 2 6 6 4";
        return 0;
    }
    ve<ve<int>> a(n, ve<int>(n));
    if (n % 4 == 0) {
        int cnt = 0;
        int now = 0;

        for (int i = 0; i < n; i += 2) {
            for (int j = 0; j < i/2; ++j)
                a[i][j] = i + 2;
            for (int j = i/2; j < n; ++j)
                a[i][j] = i + 1;
            for (int j = 0; j < n - i/2; ++j)
                a[i + 1][j] = i + 2;
            for (int j = n - i/2; j < n; ++j)
                a[i + 1][j] = i + 1;
        }
        for (int i = 0; i < n; i += 4) {
            swap(a[i + 1][n - i / 2 - 1], a[i + 2][i / 2 + 1]);
        }
        for (auto &x : a)
            cout << x;
        return 0;
    }
    if (n % 4 == 1) {
        for (int i = 0; i < n; ++i)
            a[0][i] = 1;
        for (int i = 1; i < n; i += 2) {
            for (int j = 0; j < (i+1)/2; ++j)
                a[i][j] = i + 2;
            for (int j = (i+1)/2; j < n; ++j)
                a[i][j] = i + 1;
            for (int j = 0; j < n - (i+1)/2; ++j)
                a[i + 1][j] = i + 2;
            for (int j = n - (i+1)/2; j < n; ++j)
                a[i + 1][j] = i + 1;
        }
        for (int i = 1; i < n; i += 4) {
            swap(a[i + 1][n - (i + 1) / 2 - 1], a[i + 2][(i + 1) / 2 + 1]);
        }
        for (auto &x : a)
            cout << x;
        return 0;
    }
    if (n % 4 == 3) {
        for (int i = 0; i < n - 3; i += 2) {
            for (int j = 0; j < i/2; ++j)
                a[i][j] = i + 2;
            for (int j = i/2; j < n; ++j)
                a[i][j] = i + 1;
            for (int j = 0; j < n - i/2; ++j)
                a[i + 1][j] = i + 2;
            for (int j = n - i/2; j < n; ++j)
                a[i + 1][j] = i + 1;
        }
        for (int i = 0; i < n - 3; i += 4) {
            swap(a[i + 1][n - i / 2 - 1], a[i + 2][i / 2 + 1]);
        }
        for (int i = 0; i < n - 4; ++i)
            a[n-3][i] = n - 2;
        a[n-3][n-4] = a[n-3][n-3] = n - 1;
        a[n-3][n-2] = a[n-3][n-1] = n;
        a[n-2][0] = n - 2;
        for (int i = 1; i < n -1; ++i)
            a[n-2][i] = n - 1;
        a[n-2][n-1] = n;
        a[n-1][0] = a[n-1][1] = a[n-1][2] = n - 2;
        for (int i = 3; i < n; ++i)
            a[n-1][i] = n;
        for (auto &x : a)
            cout << x;
        return 0;
    }
    for (int i = 0; i < n - 6; i += 2) {
        for (int j = 0; j < i/2 + 2; ++j)
            a[i][j] = i + 2;
        for (int j = i/2 + 2; j < n; ++j)
            a[i][j] = i + 1;
        for (int j = 0; j < n - i/2 - 2; ++j)
            a[i + 1][j] = i + 2;
        for (int j = n - i/2 - 2; j < n; ++j)
            a[i + 1][j] = i + 1;
    }
    for (int i = 0; i < n - 6; i += 4) {
        swap(a[i + 1][n - i / 2 - 2 - 1], a[i + 2][i / 2 + 2 + 1]);
    }
    for (int i = 0; i < n; ++i)
        a[n-6][i] = n - 5;
    for (int i = 0; i < n  -1; ++i)
        a[n-5][i] = n - 4;
    a[n-5][n-1] = n - 3;
    a[n-4][0] = n - 4;
    a[n-4][1] = n - 2;
    for (int i = 2; i < n; ++i)
        a[n-4][i] = n - 3;
    for (int i = 0; i < n - 2; ++i)
        a[n-3][i] = n - 2;
    a[n-3][n-2] = n - 1;
    a[n-3][n-1] = n - 3;
    a[n-2][0] = n - 2;
    for (int i = 1; i < n/2; ++i)
        a[n-2][i] = n;
    for (int i = n/2; i < n; ++i)
        a[n-2][i] = n - 1;
    for (int i = 0; i < n/2 + 1; ++i)
        a[n-1][i] = n;
    for (int i = n/2 + 1; i < n; ++i)
        a[n-1][i] = n - 1;
    for (auto &x : a)
        cout << x;
    return 0;
}