#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

void solve();

#define int long long
#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define vi vector<ll>
#define vii vector<vi>
#define vip vector<pair<ll, ll>>
#define viip vector<vip>
#define double long double
const int N = 3e5 + 10, MOD = 1e9 + 7;
const int INF = 1e8;
const double EPS = 1e-8, pi = acos(-1);

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

double dist(double ax,double ay,double bx,double by){
    return sqrtl((ax-bx)*(ax-bx)+(ay-by)*(ay-by));
}

struct pt{
    double x, y;

    double operator%(pt b) {
        return x * b.y - y * b.x;
    }

    double operator*(pt b) {
        return x * b.x + y * b.y;
    }

    double len() {
        return (sqrt((double) x * x + y * y));
    }
};

pair<double, double> pov(double x1, double y1, double a) {
    pt p1 = {x1, y1};
    pt p2 = {1, 0};
    double b = (atan2(p2 % p1, p2 * p1));
    a += b;
    double len = p1.len();
    double y2 = len * sin(a);
    double x2 = len * cos(a);
    return {x2, y2};
}

void solve() {
    double ax,ay,bx,by;
    cin>>ax>>ay>>bx>>by;

    int n;
    cin>>n;
    vector<int> a(n);
    int sum=0;
    for(int i=0;i<n;i++){
        cin>>a[i];
        sum+=a[i];
    }
    double cur=dist(ax,ay,bx,by);
    if(sum<cur){
        cout<<"Impossible"<<endl;
        return;
    }
    cout<<"Possible"<<endl;
    vector<pair<double,double>> ans;
    for(int i=0;i<n;i++){
        sum-=a[i];
        double l=-EPS,r=pi+EPS;
        cur=dist(ax,ay,bx,by);
        double rad=a[i];
        for(int j=0;j<1000;j++){
            double m=(l+r)/2;
            double curd=sqrtl(rad*rad+cur*cur-2*cur*rad*cosl(m));
            if(curd>sum){
                r=m;
            }else{
                l=m;
            }
        }
        if(cur-rad<-EPS){
            assert(0);
        }
        double nx=bx-ax,ny=by-ay;
        nx=(nx/(cur/rad));
        ny=(ny/(cur/rad));
        auto [vx,vy]=pov(nx,ny,l);
        vx+=ax;
        vy+=ay;
        ans.emplace_back(vx,vy);
        ax=vx;
        ay=vy;
    }
    cout<<fixed<<" "<<setprecision(20);
    for(auto [x,y]:ans){
        cout<<x<<" "<<y<<endl;
    }
}