#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
using ll = long long;
#define ld long double
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;


const int MOD = 998244353;

struct pnt {
    int x, y;
};

pnt vec(pnt a, pnt b) {
    return {b.x - a.x, b.y - a.y};
}

int cross(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x) * (a.x * b.y - a.y * b.x);
}

int len(pnt a) {
    return a.x * a.x + a.y * a.y;
}

ld get(pnt a, pnt b, pnt p) {
    pnt ab = vec(a, b);
    pnt ap = vec(a, p);
    int l = len(ab);
    int r = cross(ab, ap);
    ld d = (ld)r / (ld)l;

    return d;
}

void solve() {
    pnt a, b, p;
    cin >> a.x >> a.y;
    cin >> b.x >> b.y;
    cin >> p.x >> p.y;
    ld ab = get(a, b, p);
    ld ap = get(a, p, b);
    ld bp = get(b, p, a);
    if (ab < ap && ab < bp) {
        cout << a.x << ' ' << a.y << ' ' << b.x << ' ' << b.y;
    } else if (ap < ab && ap < bp) {
        cout << a.x << ' ' << a.y << ' ' << p.x << ' ' << p.y;
    } else {
        cout << b.x << ' ' << b.y << ' ' << p.x << ' ' << p.y;
    }
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }

}