#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ld = long double;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

int n, m, s;

bool check2(ll x, ll y) {
    if (x * (m - y) + (n - x) * y >= s)return true;
    return false;
}

bool check(ll x, ll y) {
    if (x * y + (n - x) * (m - y) >= s)return true;
    return false;
}

void solve() {

    cin >> n >> m >> s;
    if (s == n * m) {
        cout << 0;
        return;
    }
    if (s % n == 0 || s % m == 0 || m==1 || n==1) {
        cout << 1;
        return;
    }
    if (s < n || s < m || s > n * (m - 1) || s > (n - 1) * m) {
        cout << 2;
        return;
    }
    for (int i = 1; i < n; i++) {
        if (s % i == 0 && s / i <= m) {
            cout << 2;
            return;
        }
    }
    //binary search 1
    for (ll i = 1; i <= n / 2; i++) {
        int l = 1, r = m;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (check2(i, mid)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if(i*l+(n-i)*(m-l)==s){
            cout << 2;
            return;
        }
    }


    //bin search 2

    for (ll i = 1; i <= n / 2; i++) {
        int l = 0, r = m-1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (check(i, mid)) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if(i*(m-r)+(n-i)*r==s){
            cout << 2;
            return;
        }
    }

    cout << 3;
    return;

}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}