#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ld = long double;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

struct vec {
    ld x = 0, y = 0;

    vec operator-(vec oth) {
        return {x - oth.x, y - oth.y};
    }

    vec operator+(vec oth) {
        return {x + oth.x, y + oth.y};
    }

    vec operator*(ld d) {
        return {x * d, y * d};
    }

    ld len2() {
        return x * x + y * y;
    }

    ld len() {
        return sqrtl(x * x + y * y);
    }

    vec rotate() {
        return {-y, x};
    }

    vec rotate(ld p) {
        return rotate(cosl(p), sinl(p));
    }

    vec rotate(ld c, ld s) {
        vec v = *this;
        vec u = v.rotate();
        vec w = v * c + u * s;
        return w;
    }
};

void solve() {
    vec v1, v0;
    int n;
    cin >> v1.x >> v1.y >> v0.x >> v0.y >> n;
    vector<ld> a(n + 1);
    a[0] = (v1 - v0).len();
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    ld mx = a[0], pos = 0, sum = a[0];
    for (int i = 1; i <= n; ++i) {
        if (mx <= a[i]) {
            mx = a[i];
            pos = i;
        }
        sum += a[i];
    }
    if (2 * mx > sum) {
        cout << "Impossible";
        return;
    }
    cout << "Possible\n";
    if (pos != 0) {
        if (true) {
            int x = 0;
            for (int i = pos - 1; i > 0; --i) {
                x += a[i];
                int y = sum - mx - x;
                if (x <= mx + y && y <= mx + x) {
                    vec v = v1;
                    vec vc = (v1 - v0) * ((ld) 1 / a[0]);
                    for (int j = 1; j < i; ++j) {
                        v = v + vc * a[j];
                        cout << v.x << ' ' << v.y << '\n';
                    }
                    ld p = acosl((mx * mx - x * x - y * y) / (-2 * x * y));
                    vc = vc.rotate(M_PI - p);
                    for (int j = i; j < pos; ++j) {
                        v = v + vc * a[j];
                        cout << v.x << ' ' << v.y << '\n';
                    }
                    p = acosl((y * y - x * x - mx * mx) / (-2 * mx * x));
                    vc = vc.rotate(M_PI - p);
                    v = v + vc * mx;
                    cout << v.x << ' ' << v.y << '\n';
                    p = acosl((x * x - y * y - mx * mx) / (-2 * y * x));
                    vc = vc.rotate(M_PI - p);
                    for (int j = pos + 1; j <= n; ++j) {
                        v = v + vc * a[j];
                        cout << v.x << ' ' << v.y << '\n';
                    }
                    return;
                }
            }
        }
        if (true) {
            int x = 0;
            for (int i = pos + 1; i <= n; ++i) {
                x += a[i];
                int y = sum - mx - x;
                if (x <= mx + y && y <= mx + x) {
                    vec v = v1;
                    vec vc = (v1 - v0) * ((ld) 1 / a[0]);
                    for (int j = 1; j < pos; ++j) {
                        v = v + vc * a[j];
                        cout << v.x << ' ' << v.y << '\n';
                    }
                    ld p = acosl((x * x - mx * mx - y * y) / (-2 * mx * y));
                    vc = vc.rotate(M_PI - p);
                    v = v + vc * mx;
                    cout << v.x << ' ' << v.y << '\n';
                    p = acosl((y * y - x * x - mx * mx) / (-2 * mx * x));
                    vc = vc.rotate(M_PI - p);
                    for (int j = pos; j <= i; ++j) {
                        v = v + vc * a[j];
                        cout << v.x << ' ' << v.y << '\n';
                    }
                    p = acosl((mx * mx - x * x - y * y) / (-2 * x * y));
                    vc = vc.rotate(M_PI - p);
                    for (int j = pos + 1; j <= n; ++j) {
                        v = v + vc * a[j];
                        cout << v.x << ' ' << v.y << '\n';
                    }
                    return;
                }
            }
        }
    } else {
        int x = 0;
        for (int i = 1; i <= n; ++i) {
            x += a[i];
            int y = sum - mx - x;
            if (x <= mx + y && y <= mx + x) {
                vec v = v1;
                vec vc = (v1 - v0) * ((ld) 1 / a[0]);
                ld p = acosl((y * y - x * x - mx * mx) / (-2 * mx * x));
                vc = vc.rotate(M_PI - p);
                for (int j = 1; j <= i; ++j) {
                    v = v + vc * a[j];
                    cout << v.x << ' ' << v.y << '\n';
                }
                p = acosl((mx * mx - x * x - y * y) / (-2 * x * y));
                vc = vc.rotate(M_PI - p);
                for (int j = i + 1; j <= n; ++j) {
                    v = v + vc * a[j];
                    cout << v.x << ' ' << v.y << '\n';
                }
                return;
            }
        }
    }
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}