#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ld = long double;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
        if (a[i].first > a[i].second) {
            swap(a[i].first, a[i].second);
        }
    }
    sort(a.begin(), a.end(), [](pair<int, int> q, pair<int, int> w) {
        if (q.first == w.first) {
            return q.second < w.second;
        }
        return q.first < w.first;
    });
    int ok = 1;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i].first > a[i + 1].first || a[i].second > a[i + 1].second) {
            ok = 0;
            break;
        }
    }
    if (ok) {
        for (auto [it, it1]: a) {
            cout << it << ' ';
        }
        cout << '\n';
        for (auto [it, it1]: a) {
            cout << it1 << ' ';
        }
    } else {
        cout << -1;
    }
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
