#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    double x, y;

    pnt(double _x, double _y) {
        x = _x;
        y = _y;
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    string s;
    cin>>n>>s;
    int cnt = s.size();
    ll f = 0;
    bool b = false;
    for (int i = 0; i < s.size(); ++i) {
        if(s[i]=='0'&&b){
            f*=10;
            f+=(s[i]-'0');
        }else if(s[i]!='0'){
            b = true;
            f*=10;
            f+=(s[i]-'0');
        }
    }
    ll p = 1;
    while(cnt>0){
        p*=10;
        cnt--;
    }
    ll g = gcd(p,f);
    f/=g;
    p/=g;
    if(f<1000000&&p<1000000){
        cout<<"YES\n"<<f<<" "<<p;
    }else {
        cout << "NO";
    }
    return 0;
}
