#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int x = 0;
    cout << "? 4 4\n";
    cout.flush();
    char c;
    cin >> c;
    if (c == '+') {
        x += 4;
    }
    cout << "? 2 2\n";
    cout.flush();
    cin >> c;
    if (c == '+') {
        x += 2;
    }
    cout << "? 1 1\n";
    cout.flush();
    cin >> c;
    if (c == '+') {
        x++;
    }

    int a = 0;
    cout << "? -4 -4\n";
    cout.flush();
    cin >> c;
    if (c == '+') {
        a += 4;
    }
    cout << "? -2 -2\n";
    cout.flush();
    cin >> c;
    if (c == '+') {
        a += 2;
    }
    cout << "? -1 -1\n";
    cout.flush();
    cin >> c;
    if (c == '+') {
        a++;
    }
    cout << "? -1 1\n";
    cout.flush();
    cin >> c;
    if (c == '-') {
        cout << "! " << (char) ('a' + a - x) << 8 - x << '\n';
    }else{
        cout << "! " << (char) ('h' - x) << 1 + a - x << '\n';
    }
    cout.flush();
    return 0;
}