#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    int x, y;

    pnt(int _x, int _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

double len(pnt a) {
    return sqrt(a.x * a.x + a.y * a.y);
}

double two(pnt a, pnt b, pnt c) {
    return abs(((b - c) ^ (a - c)) / len(a - b));
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    pnt a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    cout << fixed << setprecision(10);
    double o = two(a, b, c);
    double d = two(a, c, b);
    double t = two(b, c, a);
    if (o < d && o < t) {
        cout << a << " " << b;
    } else if (d < t && d < o) {
        cout << a << " " << c;
    } else {
        cout << b << " " << c;
    }
    return 0;
}
