#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct pnt {
    ll x, y;

    pnt(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    pnt() {
    }
};

double operator*(pnt a, pnt b) {
    return (a.x * b.x + a.y * b.y);
}

double operator^(pnt a, pnt b) {
    return (a.x * b.y - a.y * b.x);
}

pnt operator-(pnt a, pnt b) {
    return pnt(a.x - b.x, a.y - b.y);
}

pnt operator+(pnt a, pnt b) {
    return pnt(a.x + b.x, a.y + b.y);
}

istream &operator>>(istream &in, pnt a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, pnt a) {
    out << a.x << " " << a.y;
    return out;
}

double angle(pnt a, pnt b) {
    return atan2(a ^ b, a * b);
}

ll len(pnt a) {
    return a.x * a.x + a.y * a.y;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll a1, a2, b1, b2, c1, c2;
    cin >> a1 >> a2 >> b1 >> b2 >> c1 >> c2;
    ll q = (a1 - b1) * (a1 - b1) + (a2 - b2) * (a2 - b2);
    ll w = (c1 - b1) * (c1 - b1) + (c2 - b2) * (c2 - b2);
    ll e = (a1 - c1) * (a1 - c1) + (a2 - c2) * (a2 - c2);
    if (q >= w && q >= e) {
        cout << a1 << " " << a2 << " " << b1 << " " << b2 << " ";
    } else {
        if (w >= q && w >= e) {
            cout << c1 << " " << c2 << " " << b1 << " " << b2 << " ";
        } else {
            cout << a1 << " " << a2 << " " << c1 << " " << c2 << " ";
        }
    }
    return 0;
}