//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx, avx2, bmi2,fma")

#include <bits/stdc++.h>

using namespace std;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}


#define int long long
#define ld long double
constexpr int MAXN = 2e5, INF = 2e9, MOD = 1e9 + 7;
const ld EPS = 1e-12;

int C[MAXN], d[MAXN], ver[MAXN];

void solve() {
    int n, q;
    cin >> n >> q;
    vector<map<int, int>> mp(n);
    int ans = 0;
    while (q--) {
        char h;
        cin >> h;
        int v, u, c;
        cin >> v >> u >> c;
        v--, u--;
        if (h == '+') {
            if (mp[v][c] == 0 && mp[u][c] == 0) {
                C[c]++;
                mp[v][c]++, mp[u][c]++;
                if (d[c] == 0) {
                    ans++;
                }
            } else if (mp[v][c] == 1 || mp[u][c] == 1) {
                mp[v][c]++, mp[u][c]++;
                if (d[c] == 0) {
                    ans -= C[c];
                }
                d[c]++;
                C[c]++;
            } else {
                mp[v][c]++, mp[u][c]++;
                C[c]++;
            }
        } else {
            mp[v][c]--, mp[u][c]--;
            if (mp[v][c] == 1 || mp[u][c] == 1) {
                C[c]--;
                d[c]--;
                if (d[c] == 0) {
                    ans += C[c];
                }
            } else if (mp[v][c] == 0 && mp[u][c] == 0) {
                if (d[c] == 0) {
                    ans--;
                }
                C[c]--;
            } else {
                C[c]--;
            }
        }
        cout << ans << '\n';
    }
}