//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx, avx2, bmi2,fma")

#include <bits/stdc++.h>

using namespace std;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}


#define int long long
#define ld long double
constexpr int MAXN = 2e5, INF = 2e9, MOD = 1e9 + 7;
const ld EPS = 1e-12;

void solve(){
    int n;
    cin >> n;
    vector<pair<int,int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    for (int i = 0; i < n; i++) {
        if (a[i].first > a[i].second) {
            swap(a[i].first, a[i].second);
        }
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n-1; i++) {
        if (a[i].second > a[i+1].second ) {
            cout << -1;
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << a[i].first << ' ';
    }
    cout << '\n';
    for (int i=0;i<n;i++) {
        cout << a[i].second << ' ';
    }
}