//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx, avx2, bmi2,fma")

#include <bits/stdc++.h>

using namespace std;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}


#define int long long
#define ld long double
constexpr int MAXN = 2e5, INF = 2e9, MOD = 1e9 + 7;
const ld EPS = 1e-12;

struct Point {
    int x, y;

    Point(ld x, ld y) : x(x), y(y) {}

    Point() : x(0), y(0) {}

};

int len(Point a, Point b) {
    auto sq = [] (int x) { return x * x; };
    return sq(a.x - b.x) + sq(a.y - b.y);
}

struct Line {
    int a, b, c;

    Line(Point x, Point y) {
        a = x.y - y.y;
        b = y.x - x.x;
        c = (x.x * y.y - y.x * x.y);
    }

    ld pl(Point p) const {
        return abs((a * p.x + b * p.y + c)) / sqrt(a * a + b * b);
    }
};

void solve() {
    Point a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    int len1= len(a,b);
    int len2 = len(a,c);
    int len3=len(b,c);
    int mx = max({len1,len2,len3});
    if (len1 == mx) {
        cout << a.x <<' ' << a.y << ' ' << b.x << ' ' << b.y;
    } else if (len2 == mx) {

        cout << a.x <<' ' << a.y << ' ' << c.x << ' ' << c.y;
    } else {

        cout << c.x <<' ' << c.y << ' ' << b.x << ' ' << b.y;
    }
}