#include <iostream>
#include <cmath>
#include <algorithm>

int solve(int a, int b) {
    int m = std::max(a, b), n = std::min(a, b);

    while (m % n != 0) {
        int temp = m;
        n = m % n;
        m = temp;
    }

    return n;
}

int main() {
    std::size_t first, a;
    std::cin >> first >> a;
    std::size_t b = std::pow(10, first);

    if (0 < a && a < b && b < (std::size_t)std::pow(10, 6)) {
        std::cout << "YES\n" << a << ' ' << b << '\n';
    } else {
        std::cout << "NO\n";
    }

    return 0;
}
