import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        long x1 = nextLong();
        long y1 = nextLong();
        long x2 = nextLong();
        long y2 = nextLong();
        long x3 = nextLong();
        long y3 = nextLong();
        long l12 = (long)Math.pow(Math.abs(x2 - x1), 2) + (long)Math.pow(Math.abs(y2-y1), 2);
        long l13 = (long)Math.pow(Math.abs(x3 - x1), 2) + (long)Math.pow(Math.abs(y3-y1), 2);
        long l23 = (long)Math.pow(Math.abs(x2 - x3), 2) + (long)Math.pow(Math.abs(y2-y3), 2);
        long p = (long)(Math.sqrt(l12) + Math.sqrt(l13) + Math.sqrt(l23)) / 2;
        long s = (long)((double)p * ((double)p - Math.sqrt(l12)) * ((double)p - Math.sqrt(l13)) * ((double) p-Math.sqrt(l23)));
        double h1 = Math.sqrt(s*4/l23);
        double h2 = Math.sqrt(s*4/l13);
        double h3 = Math.sqrt(s*4/l12);
        if(h1 <= h2 && h1 <= h3) {
            out.println(x2 + " " + y2 + " " + x3 + " " + y3);
        } else if(h2 <= h1 && h2 <= h3) {
            out.println(x1 + " " + y1 + " " + x3 + " " + y3);
        } else {
            out.println(x2 + " " + y2 + " " + x1 + " " + y1);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}